module GrowViral
  module Keystore
    class AccountCreator
      def self.create(*args)
        new(*args).create
      end

      attr_reader :application_id, :handle, :uid, :token, :secret, :config
      def initialize(application_id, handle, uid, token, secret, deps)
        @application_id = application_id
        @handle = handle
        @uid = uid
        @token = token
        @secret = secret
        @config = deps[:config]
      end

      def create
        response = Net::HTTP.post_form(uri, form_data)
        Account.new JSON.parse(response.body)
      end

      def uri
        @uri ||= URI.parse("#{config.host}/applications/#{application_id}/accounts")
      end

      def form_data
        {
          "account[handle]" => handle,
          "account[uid]" => uid,
          "account[token]" => token,
          "account[secret]" => secret
        }
      end
    end
  end
end


