module GrowViral
  module Keystore
    class ApplicationFetcher
      def self.fetch(*args)
        new(*args).fetch
      end

      attr_reader :provider, :name, :config
      def initialize(provider, name, deps)
        @provider = provider
        @name = name
        @config = deps[:config]
      end

      def fetch
        response = Net::HTTP.get_response(uri)
        Application.new JSON.parse(response.body)
      end

      def uri
        @uri ||= URI.parse("#{config.host}/applications/#{name}?provider=#{provider}")
      end
    end
  end
end

