module GrowViral
  module Keystore
    class Client

      attr_reader :config
      def initialize(env)
        @config = Configuration.new(env)
      end

      def fetch_application(provider, name)
        ApplicationFetcher.fetch(provider, name, config: config)
      end

      def account_exists?(app_id, handle)
        AccountFetcher.exists?(app_id, handle, config: config)
      end

      def fetch_account(app_id, handle)
        AccountFetcher.fetch(app_id, handle, config: config)
      end

      def create_account(app_id, handle, uid, token, secret)
        AccountCreator.create(app_id, handle, uid, token, secret, config: config)
      end
    end
  end
end
